/* Faan Tone Liu
 * Example program for comp 1671
 * Shows how to pass an array to a function.
 * Don't forget that arrays are always pass by  reference.
 */
#include <iostream>
using namespace std;

// tells how many integers we'll input from the user
const int num_integers(10);

// prototype - this function returns the minimum value of an integer array
int array_minimum(int array[], int array_size);

int main()
{
    int arr[num_integers];  // declare an array of integers:
    int i;

    // input numbers into array:
    for (i=0; i < num_integers; i++) {
        cout << "Please type an integer: ";
        cin >> arr[i];
    }

    // output the minimum value:
    cout << "The smallest integer in your list is " <<
        array_minimum(arr, num_integers) << endl;

    return 0;
}

//  find the minimum.  Start with min as the value of the first element
//  in the array.  Then traverse the array, looking at each element and
//  update the min value each time we find a smaller value in the array.
int array_minimum(int integer_array[], int arr_size)
{
    int min;                // variable to store the running minimum
    int i;

    min = integer_array[0];
    // start at 1 - because we've already looked at element 0
    for (i=1; i < arr_size; i++) {
        if (integer_array[i] < min)
            min = integer_array[i];
    }
    
    // return the smallest integer in the array
    return min;
}
